type ColorStorage
' 0 AlphaValue
' 1 Clean
' 2 Black
' 3 White
' 4 WarnRed
' 5 WarnYellow
' 6 WarnGreen
' 7 Pen
' 8 BackGround
' 9 WinFrame
' 10 WinFrameUnselected
' 11 WinText
' 12 WinTextUnselected
' 13 GadBody
' 14 GadBodySelected
' 15 GadText
' 16 GadTextSelected
' 17 HoverFX
' 18 HoverFXSelected
' 19 HoverFXText
' 20 HoverFXTextSelected
' 21 GadSleepPattern
' 22 SCR_Container
' 23 EBX_Pen
' 24 EBX_BackGround
' 25 EBX_Cursor
' 26 LBX_BackGround
' 27 LBX_BackGroundSelected
' 28 LBX_BackGroundHoverFX
' 29 LBX_BackGroundSelectedHoverFX
' 30 LBX_DirUnselected
' 31 LBX_DirSelected
' 32 LBX_FileUnselected
' 33 LBX_FileSelected
' 34 LBX_EntryInactive
' 35 MNG_BackGround
' 36 MNG_Text
' 37 MNG_TextInactive
' 38 MNG_HoverFX
' 39 MNG_HoverFXText
' 40 DGR_DataBackGround
' 41 DGR_DataBackGroundSelected
' 42 DGR_InfoBackGround
' 43 DGR_InfoBackGroundSelected
' 44 DGR_Text
' 45 DGR_TextSelected
' 46 DGR_Frame
' 47 DGR_Cursor

  Storage(47) as ulong

  declare property AlphaValue (Value as ubyte)   
  declare property Cleaning as ulong
  declare property Cleaning (RGBValue as ulong)
  declare property Black as ulong
  declare property White as ulong
  declare property WarnRed as ulong
  declare property WarnYellow as ulong  
  declare property WarnGreen as ulong
  declare property Pen as ulong
  declare property Pen (RGBValue as ulong)
  declare property BackGround as ulong
  declare property BackGround (RGBValue as ulong)
  declare property WinFrame as ulong
  declare property WinFrame (RGBValue as ulong)
  declare property WinFrameUnselected as ulong
  declare property WinFrameUnselected (RGBValue as ulong)
  declare property WinText as ulong
  declare property WinText (RGBValue as ulong)
  declare property WinTextUnselected as ulong
  declare property WinTextUnselected (RGBValue as ulong)
  declare property GadBody as ulong
  declare property GadBody (RGBValue as ulong)
  declare property GadBodySelected as ulong
  declare property GadBodySelected (RGBValue as ulong)
  declare property GadText as ulong
  declare property GadText (RGBValue as ulong)
  declare property GadTextSelected as ulong
  declare property GadTextSelected (RGBValue as ulong)
  declare property HoverFX as ulong
  declare property HoverFX (RGBValue as ulong)
  declare property HoverFXSelected as ulong
  declare property HoverFXSelected (RGBValue as ulong)
  declare property HoverFXText as ulong
  declare property HoverFXText (RGBValue as ulong)
  declare property HoverFXTextSelected as ulong
  declare property HoverFXTextSelected (RGBValue as ulong)
  declare property GadSleepPattern as ulong
  declare property GadSleepPattern (RGBValue as ulong)
  declare property SCR_Container as ulong
  declare property SCR_Container (RGBValue as ulong)
  declare property EBX_Pen as ulong
  declare property EBX_Pen (RGBValue as ulong)
  declare property EBX_BackGround as ulong
  declare property EBX_BackGround (RGBValue as ulong)
  declare property EBX_Cursor as ulong
  declare property EBX_Cursor (RGBValue as ulong)
  declare property LBX_BackGround as ulong
  declare property LBX_BackGround (RGBValue as ulong)
  declare property LBX_BackGroundSelected as ulong
  declare property LBX_BackGroundSelected (RGBValue as ulong)
  declare property LBX_BackGroundHoverFX as ulong
  declare property LBX_BackGroundHoverFX (RGBValue as ulong)
  declare property LBX_BackGroundSelectedHoverFX as ulong
  declare property LBX_BackGroundSelectedHoverFX (RGBValue as ulong)
  declare property LBX_DirUnselected as ulong
  declare property LBX_DirUnselected (RGBValue as ulong)
  declare property LBX_DirSelected as ulong
  declare property LBX_DirSelected (RGBValue as ulong)
  declare property LBX_FileUnselected as ulong
  declare property LBX_FileUnselected (RGBValue as ulong)
  declare property LBX_FileSelected as ulong
  declare property LBX_FileSelected (RGBValue as ulong)
  declare property LBX_EntryInactive as ulong
  declare property LBX_EntryInactive (RGBValue as ulong)
  declare property MNG_BackGround as ulong
  declare property MNG_BackGround (RGBValue as ulong)
  declare property MNG_Text as ulong
  declare property MNG_Text (RGBValue as ulong)
  declare property MNG_TextInactive as ulong
  declare property MNG_TextInactive (RGBValue as ulong)
  declare property MNG_HoverFX as ulong
  declare property MNG_HoverFX (RGBValue as ulong)
  declare property MNG_HoverFXText as ulong
  declare property MNG_HoverFXText (RGBValue as ulong)
  declare property DGR_DataBackGround as ulong
  declare property DGR_DataBackGround (RGBValue as ulong)
  declare property DGR_DataBackGroundSelected as ulong
  declare property DGR_DataBackGroundSelected (RGBValue as ulong)
  declare property DGR_InfoBackGround as ulong
  declare property DGR_InfoBackGround (RGBValue as ulong)
  declare property DGR_InfoBackGroundSelected as ulong
  declare property DGR_InfoBackGroundSelected (RGBValue as ulong)
  declare property DGR_Text as ulong
  declare property DGR_Text (RGBValue as ulong)
  declare property DGR_TextSelected as ulong
  declare property DGR_TextSelected (RGBValue as ulong)
  declare property DGR_Frame as ulong
  declare property DGR_Frame (RGBValue as ulong)
  declare property DGR_Cursor as ulong
  declare property DGR_Cursor (RGBValue as ulong)

  declare constructor
  declare sub AlphaRules
end type

constructor ColorStorage
  AlphaValue=255
  Storage(0)=Storage(0) shl 24
  Storage(1)=&HFF00FF
  Storage(2)=&HFFFFFF
  Storage(3)=&H0
  Storage(4)=&HDD0000
  Storage(5)=&HFFDD00 
  Storage(6)=&H00DD00
  AlphaRules
end constructor

sub ColorStorage.AlphaRules
  'Regelwerk, auf welchen RGBWerten der Alphawert angewendet wird
  'hier sind es noch alle, mal sehen, ob sich es ändert
  for i as integer=1 to ubound(Storage)
    Storage(i) = (Storage(i) and &HFFFFFF) or Storage(0)
  next i  
end sub

property ColorStorage.AlphaValue (ByteValue as ubyte)'das UBYTE limitiert den Wert: 0 - 255
  Storage(0)=ByteValue
  Storage(0)=Storage(0) shl 24  
  AlphaRules
end property

'in den anderen (Farb-)Properties kann und soll separat entschieden werden, wie
'mit dem Alphawert gearbeitet wird. Im Moment machen alle Properties das gleiche:
'**********************************************
property ColorStorage.Cleaning as ulong
  Cleaning=Storage(1)
end property

property ColorStorage.Cleaning (RGBValue as ulong)
  Storage(1) = (RGBValue and &HFFFFFF) or Storage(0)
end property

'**********************************************
property ColorStorage.White as ulong
  White=Storage(2)
end property

'**********************************************
property ColorStorage.Black as ulong
  Black=Storage(3)
end property

'**********************************************
property ColorStorage.WarnRed as ulong
  WarnRed=Storage(4)
end property

'**********************************************
property ColorStorage.WarnYellow as ulong
  WarnYellow=Storage(5)
end property

'**********************************************
property ColorStorage.WarnGreen as ulong
  WarnGreen=Storage(6)
end property

'**********************************************
'**********************************************
'**********************************************
property ColorStorage.Pen as ulong
  Pen=Storage(7)
end property

property ColorStorage.Pen (RGBValue as ulong)
  Storage(7) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.BackGround as ulong
  BackGround=Storage(8)
end property

property ColorStorage.BackGround (RGBValue as ulong)
  Storage(8) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.WinFrame as ulong
  WinFrame=Storage(9)
end property

property ColorStorage.WinFrame (RGBValue as ulong)
  Storage(9) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.WinFrameUnselected as ulong
  WinFrameUnselected=Storage(10)
end property

property ColorStorage.WinFrameUnselected (RGBValue as ulong)
  Storage(10) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.WinText as ulong
  WinText=Storage(11)
end property

property ColorStorage.WinText (RGBValue as ulong)
  Storage(11) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.WinTextUnselected as ulong
  WinTextUnselected=Storage(12)
end property

property ColorStorage.WinTextUnselected (RGBValue as ulong)
  Storage(12) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.GadBody as ulong
  GadBody=Storage(13)
end property

property ColorStorage.GadBody (RGBValue as ulong)
  Storage(13) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.GadBodySelected as ulong
  GadBodySelected=Storage(14)
end property

property ColorStorage.GadBodySelected (RGBValue as ulong)
  Storage(14) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.GadText as ulong
  GadText=Storage(15)
end property

property ColorStorage.GadText (RGBValue as ulong)
  Storage(15) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.GadTextSelected as ulong
  GadTextSelected=Storage(16)
end property

property ColorStorage.GadTextSelected (RGBValue as ulong)
  Storage(16) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.HoverFX as ulong
  HoverFX=Storage(17)
end property

property ColorStorage.HoverFX (RGBValue as ulong)
  Storage(17) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.HoverFXSelected as ulong
  HoverFXSelected=Storage(18)
end property

property ColorStorage.HoverFXSelected (RGBValue as ulong)
  Storage(18) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.HoverFXText as ulong
  HoverFXText=Storage(19)
end property

property ColorStorage.HoverFXText (RGBValue as ulong)
  Storage(19) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.HoverFXTextSelected as ulong
  HoverFXTextSelected=Storage(20)
end property

property ColorStorage.HoverFXTextSelected (RGBValue as ulong)
  Storage(20) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.GadSleepPattern as ulong
  GadSleepPattern=Storage(21)
end property

property ColorStorage.GadSleepPattern (RGBValue as ulong)
  Storage(21) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.SCR_Container as ulong
  SCR_Container=Storage(22)
end property

property ColorStorage.SCR_Container (RGBValue as ulong)
  Storage(22) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.EBX_Pen as ulong
  EBX_Pen=Storage(23)
end property

property ColorStorage.EBX_Pen (RGBValue as ulong)
  Storage(23) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.EBX_BackGround as ulong
  EBX_BackGround=Storage(24)
end property

property ColorStorage.EBX_BackGround (RGBValue as ulong)
  Storage(24) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.EBX_Cursor as ulong
  EBX_Cursor=Storage(25)
end property

property ColorStorage.EBX_Cursor (RGBValue as ulong)
  Storage(25) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.LBX_BackGround as ulong
  LBX_BackGround=Storage(26)
end property

property ColorStorage.LBX_BackGround (RGBValue as ulong)
  Storage(26) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.LBX_BackGroundSelected as ulong
  LBX_BackGroundSelected=Storage(27)
end property

property ColorStorage.LBX_BackGroundSelected (RGBValue as ulong)
  Storage(27) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.LBX_BackGroundHoverFX as ulong
  LBX_BackGroundHoverFX=Storage(28)
end property

property ColorStorage.LBX_BackGroundHoverFX (RGBValue as ulong)
  Storage(28) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.LBX_BackGroundSelectedHoverFX as ulong
  LBX_BackGroundSelectedHoverFX=Storage(29)
end property

property ColorStorage.LBX_BackGroundSelectedHoverFX (RGBValue as ulong)
  Storage(29) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.LBX_DirUnselected as ulong
  LBX_DirUnselected=Storage(30)
end property

property ColorStorage.LBX_DirUnselected (RGBValue as ulong)
  Storage(30) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.LBX_DirSelected as ulong
  LBX_DirSelected=Storage(31)
end property

property ColorStorage.LBX_DirSelected (RGBValue as ulong)
  Storage(31) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.LBX_FileUnselected as ulong
  LBX_FileUnselected=Storage(32)
end property

property ColorStorage.LBX_FileUnselected (RGBValue as ulong)
  Storage(32) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.LBX_FileSelected as ulong
  LBX_FileSelected=Storage(33)
end property

property ColorStorage.LBX_FileSelected (RGBValue as ulong)
  Storage(33) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.LBX_EntryInactive as ulong
  LBX_EntryInactive=Storage(34)
end property

property ColorStorage.LBX_EntryInactive (RGBValue as ulong)
  Storage(34) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.MNG_BackGround as ulong
  MNG_BackGround=Storage(35)
end property

property ColorStorage.MNG_BackGround (RGBValue as ulong)
  Storage(35) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.MNG_Text as ulong
  MNG_Text=Storage(36)
end property

property ColorStorage.MNG_Text (RGBValue as ulong)
  Storage(36) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.MNG_TextInactive as ulong
  MNG_TextInactive=Storage(37)
end property

property ColorStorage.MNG_TextInactive (RGBValue as ulong)
  Storage(37) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.MNG_HoverFX as ulong
  MNG_HoverFX=Storage(38)
end property

property ColorStorage.MNG_HoverFX (RGBValue as ulong)
  Storage(38) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.MNG_HoverFXText as ulong
  MNG_HoverFXText=Storage(39)
end property

property ColorStorage.MNG_HoverFXText (RGBValue as ulong)
  Storage(39) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.DGR_DataBackGround as ulong
  DGR_DataBackGround=Storage(40)
end property

property ColorStorage.DGR_DataBackGround (RGBValue as ulong)
  Storage(40) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.DGR_DataBackGroundSelected as ulong
  DGR_DataBackGroundSelected=Storage(41)
end property

property ColorStorage.DGR_DataBackGroundSelected (RGBValue as ulong)
  Storage(41) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.DGR_InfoBackGround as ulong
  DGR_InfoBackGround=Storage(42)
end property

property ColorStorage.DGR_InfoBackGround (RGBValue as ulong)
  Storage(42) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.DGR_InfoBackGroundSelected as ulong
  DGR_InfoBackGroundSelected=Storage(43)
end property

property ColorStorage.DGR_InfoBackGroundSelected (RGBValue as ulong)
  Storage(43) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.DGR_Text as ulong
  DGR_Text=Storage(44)
end property

property ColorStorage.DGR_Text (RGBValue as ulong)
  Storage(44) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.DGR_TextSelected as ulong
  DGR_TextSelected=Storage(45)
end property

property ColorStorage.DGR_TextSelected (RGBValue as ulong)
  Storage(45) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.DGR_Frame as ulong
  DGR_Frame=Storage(46)
end property

property ColorStorage.DGR_Frame (RGBValue as ulong)
  Storage(46) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
'**********************************************
property ColorStorage.DGR_Cursor as ulong
  DGR_Cursor=Storage(47)
end property

property ColorStorage.DGR_Cursor (RGBValue as ulong)
  Storage(47) = (RGBValue and &HFFFFFF) or Storage(0)
end property
'**********************************************
