declare sub MasterControlProgram (mode as integer=1)
declare sub DrawScreen

declare sub Gadget_Crawler (win as sGUIWindow ptr=RootWindow, check as integer=0)
declare sub GadgetKeyboard_Crawler
declare sub GadgetKeyboard_Crawler_new

declare sub Selection_Crawler (refwin as sGUIWindow ptr)
declare sub WinStack_Crawler (winflag as ulong, win as sGUIWindow ptr=Rootwindow)
declare sub HideOnOuterClick_Crawler (refwin as sGUIWindow ptr)

declare sub ExtendedActionExecute
declare sub AsParentWindowMessage_Crawler (refwin as sGUIWindow ptr)
declare sub AsParentSelection_Crawler
declare sub AsParentSelect_Crawler (win as sGUIWindow ptr)

dim as sub (win as sGUIWindow ptr) MenuHandlerCall

declare sub Update_Crawler

declare sub GUIBuild_PutGadgetImage (win as sGUIWindow ptr, childgad as Gadget ptr, ThisImage as FB.Image ptr)
declare sub GUIBuild_Crawler(win as sGUIWindow ptr)
declare sub Hover_Crawler(win as sGUIWindow ptr)
declare sub DrawGadgets_Crawler

declare sub GetHoveredObjects(byref win as sGUIWindow ptr, byref gad as Gadget ptr)
declare function GetWindowPointer(win as sGUIWindow ptr=RootWindow,warnwin as sGUIWindow ptr=0,warnignorewin as sGUIWindow ptr=0) as sGUIWindow ptr
declare function GetWarnWindow as sGUIWindow ptr
declare function GetWarnIgnoreWindow as sGUIWindow ptr
declare function GetParentWindow(child as WinGadHeader ptr) as sGUIWindow ptr


sub MasterControlProgram (mode as integer=1) 
  dim as Gadget ptr relgad
  dim as sGUIWindow ptr warnwin,recentwin
  '!!!local, MCP only
  static as sGUIWindow ptr refwin
  static as Gadget ptr refgad

  GetSysEvents
  GADGETMESSAGE=0
  WINDOWMESSAGE=0
  MENUBASE=0
  MENUID=0  
  warnwin=GetWarnWindow
  recentwin=GetWindowPointer(,warnwin)'in jedem Schleifendurchgang wird das Fenster ermittelt, ber welchem die Maus schwebt 
  
  if LMB=HIT then refwin=recentwin'bei einem beginnenden LMB-Klick ist dieses dann das Referenzfenster   
  
  if refwin then
    'schliessen aller WFLAG_HIDECLICKEDOUTSIDE-Fenster, mit Aussnahme des Referenzfensters
    'immer erste Aktion im Fensterhandling und muss noch VOR der LMB-Gadgetbearbeitung geschehen!!
    'Gadgets knnen als implementierte Aktion auch WFLAG_HIDECLICKEDOUTSIDE-Fenster ffnen
    'HideOnOuterClick_Crawler() nach
    if LMB=HIT then HideOnOuterClick_Crawler(refwin)
    
    'solang ein Referenzfenster definiert ist, jeweils bei LMB=HIT/HOLD/RELEASE/RELEASED aufgerufen
    Gadget_Crawler(refwin,0)
    
    'NACH GadgetHandling aber immernoch in der LMB-HIT-Phase
    if LMB=HIT then
      if (MenuHandlerCall<>0) then MenuHandlerCall(refwin)' der komplette Menhandler                  
      Selection_Crawler(refwin)'Selektionsstatus aller offenen Fenster prfen/setzen      
      'Stapelhandle    
      'falls Referenzfenster WFLAG_STACKABLE ist, erstmal nach oben damit
      if refwin<>Rootwindow then 
        if (refwin->WinFlags and WFLAG_STACKABLE) then cast(sGUIWindow ptr,refwin->parent)->WindowList->MoveToLast(refwin) 
      end if                  
      '"korrigieren" des Fensterstapels bei den entsprechenden Extrema 
      WinStack_Crawler (WFLAG_BACKDROP)         
      WinStack_Crawler (WFLAG_ALWAYSONTOP)
      'Init fr LATESTGADGET
      refgad=refwin->GetGadgetPointer        
    end if
    
    if LMB=RELEASE then
      'eine Anwendung fr LATESTGADGET gibt es noch nicht
      if (refwin=recentwin) and (refgad>0) then 
        relgad=refwin->GetGadgetPointer
        if refgad=relgad then 
          LATESTGADGET=refgad
        else
          LATESTGADGET=0
        end if
      else
        LATESTGADGET=0
      end if
      refgad=0
      relgad=0 
    end if
     
    if LMB=RELEASED then   
      if (refwin->WinFlags and WFLAG_HIDECLICKEDINSIDE) then refwin->Activation=0
      if warnwin then
        cast(sGUIWindow ptr,warnwin->parent)->WindowList->MoveToLast(warnwin)
        Selection_Crawler(warnwin)
      end if

      WinStack_Crawler (WFLAG_BACKDROP)
      WinStack_Crawler (WFLAG_ALWAYSONTOP)
      WinStack_Crawler (WFLAG_WARN)      
    end if
    
    AsParentSelect_Crawler (refwin)
    
    if LMB=RELEASED then
      if refwin then refwin=0
    end if
  end if
  
  'Wheel,Keyboard,Hover - Handling

  'diverse Abstrze spter...
  'Es sollte immer sichergestellt sein dass das vorhergehend untersuchte "Eingabegert" keine GADGETMESSAGE hinterlassen hat      
  'bevor das nchste gecheckt wird!
  'Sonst wird im darauf folgenden Check die LOOPTHROUGH-Action ausgefhrt, was zum Absturz fhrt. 
  'falls notwendig einen Rettungsanker ala "if GADGETMESSAGE=0 then..." einbauen     
  if GADGETMESSAGE=0 then Gadget_Crawler(recentwin,1)' Wheel Check  
  if GADGETMESSAGE=0 then GadgetKeyboard_Crawler' Keyboard Check  
  
  'GadgetKeyboard_Crawler_new' Keyboard Check    
  Update_Crawler'geht durch jedes(!) Gadget und ruft, so es denn eine gibt, dessen Update-Routine auf  
  ExtendedActionExecute
  
  if (HoverFX=1) then Hover_Crawler(recentwin)  
  
  'if GADGETMESSAGE then WINDOWMESSAGE=GetParentWindow(GADGETMESSAGE)
  
  if WINDOWMESSAGE then
    AsParentWindowMessage_Crawler (WINDOWMESSAGE)
  end if

  '********* Rest ;)
  if mode then DrawScreen 
end sub


sub DrawScreen
  DrawGadgets_Crawler   
  sGUIScreenSet 1,1
    screenlock
      screencopy 0,1
      GUIBuild_Crawler (RootWindow) 
    screenunlock
  sGUIScreenSet 0,1
end sub


'Gadget_Crawler() geht durch die GadgetList eines Fensters und
'verknpft Ereignisse mit den in der Liste befindlichen Gadgets
'Sollte ein Gadget selbst ein Fenster haben, erfolgt ein rekursiver Aufruf
'Somit werden bei zusammengesetzten Gadgets alle Ebenen durchlaufen
'check=0 win->LMBGadgetCheck
'check=1 win->WheelGadgetCheck
sub  Gadget_Crawler (win as sGUIWindow ptr=RootWindow, check as integer=0)
  dim as Gadget ptr childgad

  childgad=win->GadgetList->GetFirst
  if childgad then
    do
      if childgad->GadgetWindow then Gadget_Crawler(childgad->GadgetWindow, check)'<<<----!!!!
      childgad=cast(Gadget ptr,childgad->next_node)
    loop until (childgad=0) or (GADGETMESSAGE<>0)'Abbruch wenn ein Ereignis auftrat
  end if 


'Variante 1:
'entweder LOOPTHROUGH oder einer der anderen  
  if GADGETMESSAGE<>0 then  
    win->LoopThroughCheck
  else  
    select case check
      case 0
        win->LMBGadgetCheck
      case 1
        win->WheelGadgetCheck
      case 2
        win->KeyboardGadgetCheck        
        
    end select    
  end if

  'sollte im untersuchten Fenster ein Ereignis festgestellt worden sein, dieses an die globale Variable "durchschleifen" 
  if win->GADMESSAGE then 
    GADGETMESSAGE=win->GADMESSAGE
    WINDOWMESSAGE=win
  else
    GADGETMESSAGE=0
    WINDOWMESSAGE=0 
  end if
end sub


sub GadgetKeyboard_Crawler
  dim as sGUIList ptr lst
  dim as sGUIWindow ptr win
  'if (GADGETMESSAGE=0) and (KEY<>"") then
    lst=WindowLists->GetFirst 
    if lst then
      do
        win=lst->GetFirst
        if win then
          do
            if win->Activation then
              'if win->Selection then Gadget_Crawler (win,2)
              Gadget_Crawler (win,2)
            end if
            win=cast(sGUIWindow ptr,win->next_node)
          loop until (win=0) or (GADGETMESSAGE<>0)
        end if
        lst=cast(sGUIList ptr,lst->next_node)
      loop until (lst=0) or (GADGETMESSAGE<>0)
    end if
  'end if
end sub


sub GadgetKeyboard_Crawler_new
  dim as sGUIList ptr lst
  dim as Gadget ptr gad
  dim as sGUIWindow ptr win,gadwin
  dim as integer result
  result=0
  lst=GadgetLists->GetFirst
  if lst then
    do
      gad=lst->GetFirst
      if gad then
        do
          'Einschalten & Edit
          if (gad->KeyboardStream=1) then 
            if (gad->oldKeyboardStream=0) then gad->DoAction(gad,GADGET_KEYBOARDON)
            if KEY<>"" then result=gad->DoAction(gad,GADGET_KEYBOARD)
            if result then GADGETMESSAGE=gad
          end if
          'Ausschalten
          if (gad->KeyboardStream=0) and (gad->oldKeyboardStream=1) then gad->DoAction(gad,GADGET_KEYBOARDOFF)                    
          gad=cast(Gadget ptr,gad->next_node)
        loop until gad=0
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until lst=0
  end if
end sub


'ohne Rekursion
sub Selection_Crawler (refwin as sGUIWindow ptr)
  dim as sGUIList ptr lst
  dim as sGUIWindow ptr win
  if (refwin->WinFlags and WFLAG_NOSELECT)=0 then 
    lst=WindowLists->GetFirst
    if lst then
      do
        win=lst->GetFirst
        if win then
          do
            if win->Activation then
              win->Selection=iif(win=refwin,1,0)
            end if
            win=cast(sGUIWindow ptr,win->next_node)
          loop until win=0
        end if
        lst=cast(sGUIList ptr,lst->next_node)
      loop until lst=0
    end if
  end if  
end sub


sub WinStack_Crawler (winflag as ulong, win as sGUIWindow ptr=Rootwindow)
  dim as _sGUIWindow ptr childwin
  dim as sGUIList ptr WindowPointerList
  dim as node ptr n
  
  'je nach winflag Suchstartpunkt definieren
  select case winflag
    case WFLAG_ALWAYSONTOP,WFLAG_WARN   
      childwin=win->WindowList->GetFirst    
    case WFLAG_BACKDROP
      childwin=win->WindowList->GetLast
  end select
 
  if childwin then                                               
    'Erzeugen einer IndexList, die die Pointer aller Fenster mit entspr. Flag aufnimmt    
    WindowPointerList=PointersLists->AppendNew (sGUIListType) 
    
    'bei mehreren bleibt deren Reihenfolge relativ zueinander erhalten    
    do
      select case winflag
        case WFLAG_ALWAYSONTOP, WFLAG_WARN
        'if childwin->Activation=1 then        
          if (childwin->WinFlags and WFLAG_ALWAYSONTOP) or (childwin->WinFlags and WFLAG_WARN) then 'wenn ein ALWAYSONTOP ODER WARN gefunden wurde, merken wir uns dieses in der WindowPointerList          
            n=WindowPointerList->AppendNew (nodeType)
            n->anypointer=cast(any ptr,childwin)
          end if
        'end if
        childwin=cast(sGUIWindow ptr,childwin->next_node)        
              
      case WFLAG_BACKDROP
        if childwin->Activation=1 then
          if (childwin->WinFlags and WFLAG_BACKDROP) then 'wenn ein BACKDROP gefunden wurde, merken wir uns dieses in der WindowPointerList
            n=WindowPointerList->AppendNew (nodeType)
            n->anypointer=cast(any ptr,childwin)
          end if
        end if
        childwin=cast(sGUIWindow ptr,childwin->prev_node)          
        
      end select

    loop until childwin=0
    
    'gefundene Windows entsprechend verschieben
    n=WindowPointerList->GetFirst
    if n then
      do
        select case winflag
          case WFLAG_ALWAYSONTOP,WFLAG_WARN              
            win->WindowList->MoveToLast( cast(sGUIWindow ptr, n->anypointer)  )
          
          case WFLAG_BACKDROP        
            win->WindowList->MoveToFirst( cast(sGUIWindow ptr, n->anypointer)  )        

        end select
        n=cast(node ptr,n->next_node)
      loop until n=0
    end if
    
    'IndexListe lschen
    PointersLists->DeleteNode(WindowPointerList)
    
    'bei WARN nicht notwendig: 
    'Nach Sortierung dieser Ebene(welche auch immer dies ist) erfolgt rekursiver Aufruf um alle ChildWindows auch entsprechend zu sortieren
    '!reuse of pointer childwin! sollte hier ungefhrlich sein
    if winflag<>WFLAG_WARN then
      childwin=win->WindowList->GetFirst
      do            
        if childwin->Activation=1 then WinStack_Crawler (winflag,childwin)         
        childwin=cast(sGUIWindow ptr,childwin->next_node)           
      loop until childwin=0
    end if
    
  end if 
end sub


sub HideOnOuterClick_Crawler (refwin as sGUIWindow ptr)
  dim as sGUIList ptr lst
  dim as sGUIWindow ptr win
  lst=WindowLists->GetFirst
  if lst then
    do
      win=lst->GetFirst
      if win then
        do
          if (win<>refwin) then
            'schliesse alle AUTOHIDE-Fenster mit Ausnahme des Referenzfensters, welches auch ein AUTOHIDE sein knnte, aber nicht muss
            if (win->WinFlags and WFLAG_HIDECLICKEDOUTSIDE) then win->Activation=0
          end if
          win=cast(sGUIWindow ptr,win->next_node)
        loop until win=0
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until lst=0
  end if 
end sub


sub ExtendedActionExecute
  dim as ExtendedAction ptr xaction
  xaction=ExtendedActionList->GetFirst
  if xaction then
    do
      if (GADGETMESSAGE<>0) and (GADGETMESSAGE=xaction->cause_gad) then xaction->DoExtendedAction(xaction)    
      xaction=cast(ExtendedAction ptr,xaction->next_node)
    loop until xaction=0
  end if
  xaction=ExtendedActionList->GetFirst
  if xaction then
    do   
      if (WINDOWMESSAGE<>0) and (WINDOWMESSAGE=xaction->cause_win) then xaction->DoExtendedAction(xaction)
      xaction=cast(ExtendedAction ptr,xaction->next_node)
    loop until xaction=0
  end if  
end sub


sub AsParentWindowMessage_Crawler (win as sGUIWindow ptr)
  if win then
    WINDOWMESSAGE=win'sieht beim Einstieg doof aus, da ja WINDOWMESSAGE als Parameter bergeben wurde... erst in der Rekursion ergibt es einen Sinn
    if (win->WinFlags and WFLAG_PARENTSELECT) then AsParentWindowMessage_Crawler(cast(sGUIWindow ptr,win->parent))  
  end if
end sub


sub AsParentSelection_Crawler
  dim as sGUIList ptr lst
  dim as sGUIWindow ptr win,parent
  dim as integer flag
  lst=WindowLists->GetFirst
  if lst then
    do
      win=lst->GetFirst
      if win then
        do     
          
          parent=win'das sieht jetzt etwas komisch aus, macht den Einstieg in den folgenden Loop aber leichter
          flag=parent->WinFlags and WFLAG_PARENTSELECT
          if parent->Selection then
            do
              if (flag<>0) and (parent->Selection=1) then 
                parent->Selection=0
                parent=cast(sGUIWindow ptr,parent->parent)
                if parent then
                  parent->Selection=1
                  flag=parent->WinFlags and WFLAG_PARENTSELECT
                end if
              end if                     
            loop until (flag=0) or (parent=0)
          end if
          win=cast(sGUIWindow ptr,win->next_node)
        loop until win=0
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until lst=0
  end if   
end sub


sub AsParentSelect_Crawler (win as sGUIWindow ptr)
  dim as integer flag
  flag=win->WinFlags and WFLAG_PARENTSELECT
  if win->Selection then
    do
      if (flag<>0) and (win->Selection=1) then 
        win->Selection=0
        win=cast(sGUIWindow ptr,win->parent)
        if (win>0) and (win<>RootWindow) then
          win->Selection=1
          flag=win->WinFlags and WFLAG_PARENTSELECT
        end if
      end if                     
    loop until (flag=0) or (win=0)
  end if  
end sub


sub Update_Crawler
  dim as sGUIList ptr lst
  dim as Gadget ptr gad
  lst=GadgetLists->GetFirst
  if lst then
    do
      gad=lst->GetFirst
      if gad then
        do
          if gad->Activation then UpdateGadget(gad)
          gad=cast(Gadget ptr,gad->next_node)
        loop until gad=0
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until lst=0
  end if 
end sub


sub Hover_Crawler(win as sGUIWindow ptr)
  dim as sGUIList ptr lst
  dim as Gadget ptr gad
  dim as sGUIWindow ptr gadwin
  '1.) alle Gadgets "unhovern", mal nichts rekursives da alle Gadgets in double linked Listen sind :)
  lst=GadgetLists->GetFirst
  if lst then
    do
      gad=lst->GetFirst
      if gad then
        do
          gad->MouseHover=0
          gad=cast(Gadget ptr,gad->next_node)
        loop until gad=0
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until lst=0
  end if
  
  '2.)Fenster aus Fensterhierachie, ber welchem die Maus schwebt (Funktion ist rekursiv)
  'win=GetWindowPointer(,warnwin) 
   
  
  '2.)alle GadgetWindows berprfen
  gadwin=GadgetWindowList->GetFirst
  if gadwin then
    do
      'verwandschaftliche Beziehung win<->gadwin ermitteln,
      'also ist das gadwin ber einen oder mehrere Parent-Gadgets Bestandteil des "echten" Windows win. 
      'wenn ja dann die Hoverroutine aufrufen    
      if GetParentWindow(gadwin)=win then gadwin->HoveringOverGadgetCheck  
      gadwin=cast(sGUIWindow ptr,gadwin->next_node)
    loop until (gadwin=0)   
  end if    
   
  win->HoveringOverGadgetCheck  
   
end sub


sub DrawGadgets_Crawler
  dim as sGUIList ptr lst
  dim as Gadget ptr gad
  lst=GadgetLists->GetFirst
  if lst then
    do
      gad=lst->GetFirst
      if gad then
        do
          if DrawRequest(gad) then gad->DoDraw (gad)'DrawGadget(gad)
          gad=cast(Gadget ptr,gad->next_node)
        loop until gad=0
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until lst=0
  end if 
end sub


sub GUIBuild_PutGadgetImage (win as sGUIWindow ptr, childgad as Gadget ptr, ThisImage as FB.Image ptr)
  dim as FB.Image ptr SourceImage   
  if childgad->Activation then
    '"normale" Gadgets haben ein eigenes Image
    'zusammengesetze Gadgets haben dies nicht, stattdessen wird dessen Fenster-Image kopiert   
    if childgad->GadgetWindow=0 then
      sourceImage=childgad->DrawBuffer->img
    else
      sourceImage=childgad->GadgetWindow->DrawBuffer->img
    end if
    
    'Ausnahme RootWindow: dieses hat selbst kein Image(ThisImage=0), darum werden hier die Child-Gadgets direkt in den Screen(Page 1) kopiert
    if ThisImage then
      put ThisImage,(win->ContentOffsetX + childgad->PosX, win->ContentOffsetY + childgad->PosY),sourceImage,trans'pset          
    else
      put (win->ContentOffsetX + childgad->PosX, win->ContentOffsetY + childgad->PosY),sourceImage,trans'pset          
    end if    
  end if
end sub


sub GUIBuild_Crawler(win as sGUIWindow ptr)
  dim as Gadget ptr childgad,parentgad
  dim as sGUIWindow ptr childwin,parentwin
  dim as FB.Image ptr ParentImage,ThisImage
  dim as sGUIList ptr lst
  
  'Imageadressen:
  if win<>RootWindow then
    'Jedes normale Fenster hat ein ParentWindow
    'dessen Image wird ins Image des ParentWindows an entprechender Position hinein kopiert     
    parentwin=cast(sGUIWindow ptr,win->parent)
    ParentImage=parentwin->DrawBuffer->img
    ThisImage=win->DrawBuffer->img
  else
    'Ein RootWindow hat weder ParentWindow noch eine eigenes Image
    'dessen Childobjekte, also Windows wie Gadgets, werden direkt auf den Screen(Page 1) kopiert
    ParentImage=0
    ThisImage=0
  end if
  
    
  'Fensteraufbau im fenstereigenen Image:
  '1. SchattenFX,"Saubermachen" und UserGFX hineinkopieren
  if win<>RootWindow then
    if win->Activation then
      'nur "echte" Fenster bekommen einen Schatten, dann ist sein Parent auch ein Fenster (KindOfType=0)
      'falls Fenster ein Gadgetfenster ist, dann ist logischerweise dessen Parent ein Gadget (KindOfType=1)           
      if cast(WinGadHeader ptr ,win->parent)->KindOfType=0 then    
        if ( win->WinFlags and WFLAG_NOSHADOW)=0 then
          WinShadow (ParentImage, parentwin->ContentOffsetX + win->PosX, parentwin->ContentOffsetY + win->PosY, win->WinWidth, win->WinHeight)             
        end if
      end if
      win->DoClearWindow (win)
    end if    
  end if

  
  '2. Child-Gagdets ins Fenster kopieren
  'Loop durch die GadgetList dieses Fensters 
  lst=win->GadgetList
  childgad=lst->GetFirst  
  if childgad then
    do             
      if childgad->GadgetWindow then GUIBuild_Crawler(childgad->GadgetWindow)
      'nach Rckkehr aus dem rekursiven Aufruf ist sichergestellt, dass sich alle
      '"Kinder und KindesKinder usw..." im GadgetWindow des aktuellen ChildGadgets verewigt haben    
      GUIBuild_PutGadgetImage (win,childgad,ThisImage)
      'nchstes Gadget holen
      childgad=cast(Gadget ptr,childgad->next_node)

    loop until childgad=0
  end if   
  
  '3.ChildWindows erstellen (rekursiv), diese kopieren sich dann selbst nach "unten" ins Image seines Parents
  'Loop durch die WindowList dieses Fensters
  childwin=win->WindowList->GetFirst
  if childwin then
    do
      'if childwin->Activation then GUIBuild_Crawler(childwin)
      GUIBuild_Crawler(childwin)
      childwin=cast(sGUIWindow ptr,childwin->next_node)
    loop until childwin=0
  end if
  
  '4. Rahmen ins Fenster zeichnen, soweit einer existieren soll
  win->DoDrawWindow (win)
  
  '5. fenstereigene Gadgets(es ist ne andere Gadgetliste als in 3. !) in Fenster kopieren (bisher nur Drag/Close)
  'Loop durch die WinGadgetList dieses Fensters 
  lst=win->WinGadgetList'!!!!!!
  childgad=lst->GetFirst  
  if childgad then
    do             
      if childgad->GadgetWindow then GUIBuild_Crawler(childgad->GadgetWindow)
      'nach Rckkehr aus dem rekursiven Aufruf ist sichergestellt, dass sich alle
      '"Kinder und KindesKinder" im GadgetWindow des aktuellen ChildGadgets verewigt haben     
      GUIBuild_PutGadgetImage (win,childgad,ThisImage)
      'nchstes Gadget holen
      childgad=cast(Gadget ptr,childgad->next_node)
    loop until childgad=0
  end if  
  
  '6. das nun fertige Fenster in sein Parent kopieren (betrifft Aussage in Step 3)
  'Ausnahme RootWindow: hier kopieren sich dessen Child-Windows direkt in den Screen(Page 1)
  if win<>RootWindow then
    if win->Activation then
      if ParentImage then
        put parentwin->DrawBuffer->img,(parentwin->ContentOffsetX + win->PosX, parentwin->ContentOffsetY + win->PosY),win->DrawBuffer->img,pset'alpha 
      else
        put (parentwin->ContentOffsetX + win->PosX, parentwin->ContentOffsetY + win->PosY),win->DrawBuffer->img,pset'alpha      
      end if
    end if
  end if
  
end sub


'******************************************************************************
sub GetHoveredObjects(byref win as sGUIWindow ptr, byref gad as Gadget ptr)
  win=0
  gad=0
  win=GetWindowPointer
  if win then gad=win->GetGadgetPointer
end sub


function GetWindowPointer(win as sGUIWindow ptr=RootWindow,warnwin as sGUIWindow ptr=0,warnignorewin as sGUIWindow ptr=0) as sGUIWindow ptr
  dim as _sGUIWindow ptr childwin,hoverwin,tmp
  dim as integer WinX,WinY
  GetGlobalPosition(win,WinX,WinY) 
  hoverwin=win
   
  if warnwin then
      
    hoverwin=warnwin
    
  else
  
    childwin=win->WindowList->GetFirst
    if childwin then
      do
        if childwin->Activation then'nur bei Activation=1 gibt es eine Antwort        
          if (MOUSEX >= WinX+childwin->PosX) and (MOUSEX < WinX+childwin->PosX+childwin->WinWidth) and _
             (MOUSEY >= WinY+childwin->PosY) and (MOUSEY < WinY+childwin->PosY+childwin->WinHeight) then
             hoverwin=childwin        
          end if
        end if  
        childwin=cast(sGUIWindow ptr,childwin->next_node)
      loop until childwin=0
    end if
    if hoverwin<>win then hoverwin=GetWindowPointer(hoverwin,0,0)'rekursiver Aufruf ohne warn/warnignore
    
  end if
  
  function=hoverwin
end function


'ausgehend von einem Gadget/Window/GadgetWindow wird nach dem "echten" Elternfenster gesucht
'Mit echten Fenstern sind RootWindow und alle via AddWindow() erzeugte Fenster gemeint!
'je nach Ausgangsobjekt, kann dessen Elternobjekt ein "echtes" Fenster(das wre dann das gesuchte), ein GadgetWindow oder ein Gadget sein
'es wird solang in der Hierachie nach oben geklettert, bis das entsprechend gefunden wurde.
function GetParentWindow(examined as WinGadHeader ptr) as sGUIWindow ptr
  dim as WinGadHeader ptr parent
  dim as integer result=0
  if examined<>RootWindow then
    do
      examined=examined->parent'Wechsel zum Eltern"Objekt"
      if examined=RootWindow then
        'gleichzeitig Abbruchbedingung, sptestens hier brauchen wir nicht mehr weitersuchen
        result=1
      else
        'wenn kein RootWindow, ist das Elternobjekt berhaupt ein Fenster, wenn ja...
        if (examined->KindOfType=0) then
          '... dann darf es KEIN! GadgetWindow sein
          if (GadgetWindowList->CheckNode(examined)=0) then result=1
        end if
      end if
    loop until result=1
  end if
  function=cast(sGUIWindow ptr,examined)
end function

/'
'ausgehend von einem Gadget/Window/GadgetWindow wird nach dem "echten" Elternfenster gesucht
function GetParentWindow(examined as WinGadHeader ptr) as sGUIWindow ptr
  dim as WinGadHeader ptr parent
  dim as integer result=0
  if examined<>RootWindow then
    do
      examined=examined->parent
      if examined=RootWindow then
        result=1
      else
        parent=examined->parent        
        if (examined->KindOfType=0) and (parent->KindOfType=0) then result=1      
      end if     
    loop until result=1
  end if
  function=cast(sGUIWindow ptr,examined)
end function
'/

function GetWarnWindow as sGUIWindow ptr
  dim as sGUIList ptr lst
  dim as sGUIWindow ptr win,warnwin
  warnwin=0
  lst=WindowLists->GetFirst
  if lst then
    do
      win=lst->GetFirst
      if win then
        do
          if win->Activation then
            if (win->WinFlags and WFLAG_WARN) then 
              if warnwin then
                if win->ActiveSince >= warnwin->ActiveSince then warnwin=win
              else
                warnwin=win
              end if
            end if
          end if
          win=cast(sGUIWindow ptr,win->next_node)
        loop until (win=0)
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until (lst=0)
  end if
   
  function=warnwin
end function


function GetDropDownWindow as sGUIWindow ptr
  dim as sGUIList ptr lst
  dim as sGUIWindow ptr win,dropdownwin
  dropdownwin=0
  lst=WindowLists->GetFirst
  if lst then
    do
      win=lst->GetFirst
      if win then
        do
          if win->Activation then
            if (win->WinFlags and WFLAG_WARNIGNORE) then 
              if dropdownwin then
                if win->ActiveSince >= dropdownwin->ActiveSince then dropdownwin=win
              else
                dropdownwin=win
              end if
            end if
          end if
          win=cast(sGUIWindow ptr,win->next_node)
        loop until (win=0)
      end if
      lst=cast(sGUIList ptr,lst->next_node)
    loop until (lst=0)
  end if
   
  function=dropdownwin
end function


'******************************************************************************
